#ifndef M_ARRAY_H
#define M_ARRAY_H
/* Pxys - An IRC ProxyScan, m_array.h
 * 
 * Copyright (C) 2001 Stephane Thiell <mbuna@undernet.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * 
 * $Id: m_array.h,v 1.4 2001/10/25 01:47:07 mbuna Exp $
 */


#include "m_structs.h"


/* Macro */

#define ZERO_STH(x) \
   memset(x, 0, sizeof(scanthread_s))


/* Prototypes */

void array_init();

void array_addclient();
void array_delclient(const char *numnick);
void array_purgeserv(unsigned char yy);
void array_fetchitem(scanthread_s * th);
int array_fetchitem_clientq(struct Client **cliH);
int array_fetchitem_scanserv(struct Server *serv, unsigned int last_client_pos, struct Client **cliH);
  
long array_countclient_from_ip(struct in_addr *addr);

struct Client * array_findclient_from_numeric(const char *numnick);
/* struct Client * array_findclient_from_ip(struct in_addr *iptr); */
struct Client * array_findclient_from_nick(const char *nick);
void array_nickchange(const char *numnick, const char *newnick);



#endif  /* M_ARRAY_H */
