#ifndef M_CACHE_H
#define M_CACHE_H
/* Pxys - An IRC ProxyScan, m_cache.h
 * 
 * Copyright (C) 2001 Stephane Thiell <mbuna@undernet.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: m_cache.h,v 1.4 2001/10/30 10:49:39 mbuna Exp $
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* Struct */

struct cacheItem {
   struct in_addr addr;
   /* time_t last; -- CCC now stored directly in hash table (cachehash) */
};

typedef struct cacheItem cacheItem;

/* Proto types */

void cache_init();
void cache_insert(struct in_addr *addr, time_t last);
time_t cache_fetch(struct in_addr *addr);
void cache_remove(struct in_addr *addr);


size_t cache_getsize();
size_t cache_status();


int cache_load();
void cache_dump();

#endif  /* M_CACHE_H */
