#ifndef M_PROXYCACHE_H
#define M_PROXYCACHE_H
/* Pxys - An IRC ProxyScan, m_proxycache.h
 * 
 * Copyright (C) 2001 Stephane Thiell <mbuna@undernet.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: m_proxycache.h,v 1.2 2001/10/29 00:33:44 mbuna Exp $
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* Structs */

typedef struct gheader_s {
   int                total;  /* number of recorded glines */
} gheader_s;

struct proxycacheItem {
   struct in_addr addr;       /* IP */
   unsigned int type;         /* Type of proxy */
   time_t expire;             /* absolute expiration time (eg. 10 days) */
};

typedef struct proxycacheItem proxycacheItem;


/* Proto types */

void proxycache_init();
void proxycache_load();
void proxycache_openlogfile();
void proxycache_close();
void proxycache_write(proxycacheItem *itemp);
void proxycache_syncfile();

void proxycache_insert(struct in_addr *addr, unsigned int type, time_t expire);
void proxycache_insert_new(struct in_addr *addr, unsigned int type, time_t expire);
int proxycache_remove(struct in_addr *addr);
int proxycache_check(struct in_addr *addr);


#endif  /* M_PROXYCACHE_H */
