/* PWorld - An IRC ProxyScan, debug.c
 * 
 * Copyright (C) 2001 Stephane Thiell
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 *
 * $Id: debug.c,v 1.1.1.1 2001/10/14 22:10:22 mbuna Exp $
 */


#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#if HAVE_PTHREAD_H == 1
#	include <pthread.h>
#endif

#include "debug.h"

#ifdef DEBUG

pthread_mutex_t mutex_debug;


void
debug(int level, const char *pattern, ...)
{
   va_list vl;
   va_start(vl, pattern);
   pthread_mutex_lock(&mutex_debug);
   vprint_debug(level, pattern, vl);
   pthread_mutex_unlock(&mutex_debug);
   va_end(vl);
}

void
vprint_debug(int level, const char *pattern, va_list vl)
{
   FILE *fp;
   char buf[0x400];
   
   vsnprintf(buf, sizeof(buf), pattern, vl);
   
   if(level >= DBLMAX)
      printf("%s\n", buf);
   
   if((fp = fopen(DEBUG_FILE, "a")) == NULL) {
      pthread_mutex_unlock(&mutex_debug);
      return;
   }
   
   fprintf(fp, "%s\n",  buf);
   
   fclose(fp);
   
   
}

#endif
