/* Pxys - An IRC ProxyScan, ms_mode.c
 * 
 * Copyright (C) 2001 Stephane Thiell <mbuna@undernet.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * 
 * $Id: ms_mode.c,v 1.6 2001/10/28 02:59:30 mbuna Exp $
 */
 
#include "config.h"


#include "ms_mode.h"
#include "m_array.h"
#include "m_log.h"
#include "m_structs.h"

#include <stdio.h>


/* ms_mode is always called in the same thread as addclient/delclient */
void
ms_mode(const char * ClientYYXXX, const char * mode)
{
   struct Client *cptr;
   int oper = 0; /* not oper'd! */
   
#ifdef N2K_SUPPORT
   cptr = array_findclient_from_numeric(ClientYYXXX);
#else
   if (*ClientYYXXX == ':')
      ClientYYXXX++;
   cptr = array_findclient_from_nick(ClientYYXXX);
#endif
   
   if(NULL == cptr) {
      log_error("ms_mode: user %s not found!\n", ClientYYXXX);
   } else {
      
      operchange(&oper, mode);
      
      if (oper && !(cptr->flags & FLAG_OPER))
         cptr->flags |= FLAG_OPER;
      else if (!oper && (cptr->flags & FLAG_OPER))
         cptr->flags &= ~FLAG_OPER;
   }
}


/* mode != NULL */
void
operchange(int * ioOper, const char * mode)
{
   int tog = true;
   char ch;
   
   while((ch = *mode++))
      switch(ch) {
         case '+':
            tog = 1;
            continue;
         case '-':
            tog = 0;
            continue;
         case 'o':
            *ioOper = tog ? 1 : 0 ;
   }
}



/* ms_mode.c */
